<?php



/**

* Gavick Image Slide I

* @package Joomla!

* @Copyright (C) 2009 Gavick.com

* @ All rights reserved

* @ Joomla! is Free Software

* @ Released under GNU/GPL License : http://www.gnu.org/copyleft/gpl.html

* @version $Revision: 1.0.0 $

**/



// access restriction

defined('_JEXEC') or die('Restricted access');

// vars

$highest_layer = 0;

// initializing variables

$URI = JURI::getInstance();



if (!function_exists('htmlspecialchars_decode')) {

        function htmlspecialchars_decode($str, $options="") {

                $trans = get_html_translation_table(HTML_SPECIALCHARS, $options);



                $decode = ARRAY();

                foreach ($trans AS $char=>$entity) {

                        $decode[$entity] = $char;

                }



                $str = strtr($str, $decode);



                return $str;

        }

}



?>



<div id="gk_is-<?php echo $this->ID;?>" class="gk_is_wrapper gk_is_wrapper-style1 clearfix">



	<div class="gk_is_preloader"><span>LOADING</span></div>



	<?php if($this->config["interface"] == 'true') : ?>

	<div class="gk_is_prev<?php if($this->config["interface_animation"] == 'true') echo ' anim'; ?>" style="top:<?php echo (($this->settings["image_y"]/2) - 23); ?>px;"><div>PREV</div></div>

	<div class="gk_is_next<?php if($this->config["interface_animation"] == 'true') echo ' anim'; ?>" style="top:<?php echo (($this->settings["image_y"]/2) - 23); ?>px;"><div>NEXT</div></div>

	<?php endif; ?>

	

	<div class="gk_is_image<?php echo ' '.$this->config['image_position']; ?>" style="width:<?php echo $this->settings["image_x"]; ?>px;height:<?php echo $this->settings["image_y"];?>px;">



		<?php for($i = 0; $i < count($this->slides); $i++) : ?>

			

			<?php 

			

				// cleaning variables

				unset($path, $title);

				// creating slide path

				$path = $URI->root().'components/com_gk3_photoslide/thumbs_big/'.$this->slides[$i]["filename"];

				// creating slide title

				$title = stripslashes(strip_tags(($this->slides[$i]["title"] == "") ? $this->slides[$i]["ctitle"] : $this->slides[$i]["title"]));	

				

			?>

			

			<div class="gk_is_slide" style="z-index: <?php echo $i+1; ?>;" title="<?php echo $title; ?>"><?php echo $path; ?></div>

			

		<?php endfor; ?>

	</div>

	

	<div class="gk_is_content" style="position:relative;margin-<?php echo $this->config['image_position']; ?>:<?php echo $this->settings["image_x"]; ?>px;">

		<?php if($this->config['show_list'] == 'true') : ?>

		<div class="gk_is_list<?php echo ' '.$this->config['list_position']; ?>" style="width:<?php echo 100 - $this->config['art_width']; ?>%;">

			<div>

				<h3>

					<?php if($this->config['list_title_small'] != '') : ?>

					<span class="title_small"><?php echo $this->config['list_title_small']; ?></span>

					<?php endif; ?>

					

					<?php if($this->config['list_title_big'] != '') : ?>

					<span class="title_big"><?php echo $this->config['list_title_big']; ?></span>

					<?php endif; ?>

				</h3>

				

				<ul>

					<?php for($i = 0; $i < count($this->slides); $i++) : ?>

					<li><?php 

						

						$str_len = JString::strlen(strip_tags(($this->slides[$i]["title"] == "") ? $this->slides[$i]["ctitle"] : $this->slides[$i]["title"]));

 					

						echo JString::substr(stripslashes(strip_tags(($this->slides[$i]["title"] == "") ? $this->slides[$i]["ctitle"] : $this->slides[$i]["title"])), 0, $this->config['list_char_count']); 

					

						if($str_len > $this->config['list_char_count']){

							echo $this->config['list_text_overflow'];

						}

					

					?></li>

					<?php endfor; ?>

				</ul>

			</div>

		</div>

		<?php endif; ?>

		

		<?php for($i = 0; $i < count($this->slides); $i++) : ?>

		

			<?php 

			

				// cleaning variables

				unset($text, $title, $link, $exploded_text);

				// creating slide text

				$text = ($this->slides[$i]["content"] == "") ? $this->slides[$i]["introtext"] : $this->slides[$i]["content"];

				$text = htmlspecialchars_decode($text);

				if($this->config["clean_xhtml"] == "true") $text = strip_tags($text);

				$exploded_text = explode(" ", stripslashes($text));

				$text = '';

				for($j = 0; $j < $this->config["wordcount"]; $j++)

				{

					if(isset($exploded_text[$j]))

					{

						$text .= $exploded_text[$j]." ";

					}

				}

				// creating slide title

				$title = stripslashes(strip_tags(($this->slides[$i]["title"] == "") ? $this->slides[$i]["ctitle"] : $this->slides[$i]["title"]));

				// creating slide link

				$link = ($this->slides[$i]["link_type"] != 0) ? JRoute::_(ContentHelperRoute::getArticleRoute($this->slides[$i]["article"], $this->slides[$i]["cid"], $this->slides[$i]["sid"])) : $this->slides[$i]["link"];

				

			?>

		

		<div class="gk_is_art gk_unvisible" style="position:absolute;z-index:<?php echo $i+5; ?>;width:<?php echo ($this->config['show_list'] == 'true') ? $this->config['art_width'] : '100'; ?>%;<?php if($this->config['show_list'] == 'true' && $this->config['list_position'] == 'left') echo 'margin-left:'.(100-$this->config['art_width']).'%;'; ?>">

			<div>

				<?php if($this->config["title"] == "true"): ?>

					<?php if($this->config["title_link"] == "true"): ?>

						<h4><a href="<?php echo $link; ?>"><?php echo $title; ?></a></h4>

					<?php else: ?>

						<h4><?php echo $title; ?></h4>

					<?php endif; ?>

				<?php endif; ?>

				<p>

					<?php echo $text; ?>

				</p>

				

				<?php if($this->config["readmore_button"] == "true") : ?>

				<a href="<?php echo $link; ?>" class="readon"><?php echo $this->config["readmore_text"]; ?></a>

				<?php endif; ?>

			</div>

		</div>

		<?php endfor; ?>

	</div>

</div>